/**
 *getStartAndEndBar
 */
void getStartAndEndBar(int ibarhtf, int &startbar, int &endbar, int htf, int ltf, int dsh=0)
{      
   
   int i, j, q, year, month, quarter;
   datetime dt.htf;     
   datetime dt.htf.end; 
    
   switch (htf)
   {
      case PERIOD_D1:

         startbar = 0; endbar = 0;     
                      
         int oneday  = (PERIOD_D1*60) - 1; // -1 is for .... like 23:59:xxxx
         int idsh    = dsh * PERIOD_H1 * 60;
   
         datetime dt.starthour, dt.endhour;
         int  sb = 0       //startbar
            , eb = 0;      //endbar                     
         
         dt.htf       = iTime( NULL, htf, ibarhtf ); 
         
         //if ( TimeHour(iTime(NULL, ltf, 0)) < dsh) dt.htf -= (oneday+1);
  
         dt.starthour = dt.htf + idsh; 
         dt.endhour   = dt.starthour + oneday; 
         if ( TimeDayOfWeek(dt.endhour) == 6 ) 
         {
            dt.endhour += (1*oneday);         
         }                     
         sb  = iBarShift ( NULL, ltf, dt.starthour ); 
         eb  = iBarShift ( NULL, ltf, dt.endhour ); 
         
         /*
         //--because of sunday bar ...
         
         if ( sb==eb && ibarhtf != 0 )
         {
            sb = -1; eb = -1;
         }
         */        
         startbar = sb;
         endbar   = eb;    
         if (startbar != -1)
         {
            if (iTime(NULL, ltf, startbar) < dt.starthour) startbar--;
         }     
                                                  
      break;
      
      case PERIOD_Q1:
         year   = TimeYear(Time[0]);
         month  = TimeMonth(Time[0]);
         
         if (month>=1 && month<=3)  quarter = 1; else   //q1
         if (month>=4 && month<=6)  quarter = 2; else   //q2         
         if (month>=7 && month<=9)  quarter = 3; else   //q3
                                    quarter = 4;        //q4
         
         for (i=0; i<=ibarhtf; i++)
         {
            if (quarter == 1)
            {
               dt.htf      = StrToTime(year + ".01.01 00:00");
               dt.htf.end  = StrToTime(year + ".04.01 00:00") - 1; // -1 = - one second           
            } 
            else 
            if (quarter == 2)
            {
               dt.htf      = StrToTime(year + ".04.01 00:00");
               dt.htf.end  = StrToTime(year + ".07.01 00:00") - 1;                
            }
            else 
            if (quarter == 3)
            {
               dt.htf      = StrToTime(year + ".07.01 00:00");
               dt.htf.end  = StrToTime(year + ".10.01 00:00") - 1;             
            }
            else 
            if (quarter == 4)
            {
               dt.htf      = StrToTime(year + ".10.01 00:00");
               dt.htf.end  = StrToTime((year+1) + ".01.01 00:00") - 1;             
            }
            
            
            if (quarter==1) 
            {
               quarter = 4;
               year--;  
            }          
            else quarter--;
            //{

            //}
         }                 
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end);  
                  
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--; 
                  
      break;  
           
      case PERIOD_Y1:
         year           = TimeYear(Time[0]) - ibarhtf;
         dt.htf      = StrToTime(year + ".01.01 00:00");
         dt.htf.end  = StrToTime(year + ".12.31 23:59");
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end);  
                  
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--; 
                  
      break;        
      
      default:
         dt.htf      = iTime( NULL, htf, ibarhtf );
         dt.htf.end  = iTime( NULL, htf, ibarhtf - 1 );
         
         startbar  = iBarShift ( NULL, ltf, dt.htf);
         endbar    = iBarShift ( NULL, ltf, dt.htf.end - (ltf * 60) );
         //current week, month         
         if (dt.htf.end < dt.htf) endbar = 0;         
         // fix iBarShift on month\week start
         if ( iTime(NULL, ltf, startbar) < dt.htf ) startbar--;    
                           
      break;
   }         
}

/**
 *getRF : Rotation Factor
 */
int getRF(int sb, int eb, int tf)
{
   int i, rf;
   for (i=sb; i>=eb; i--)
   {
      if ( gdaRates[i][_HIGH] > gdaRates[i+1][_HIGH] ) rf++;
      if ( gdaRates[i][_LOW]  > gdaRates[i+1][_LOW] )  rf++;   
      if ( gdaRates[i][_HIGH] < gdaRates[i+1][_HIGH] ) rf--;
      if ( gdaRates[i][_LOW]  < gdaRates[i+1][_LOW] )  rf--;
   }
   
   return(rf);
}


/**
 *getHHLL                                                          
*/
void getHHLL
(
     int       tf
   , int       sb
   , int       eb
   , double&   hh
   , double&   ll
)
{
   hh = iHigh ( NULL, tf, iHighest(NULL, tf, MODE_HIGH, (sb-eb)+1, eb) );
   ll = iLow  ( NULL, tf, iLowest (NULL, tf, MODE_LOW,  (sb-eb)+1, eb) );
} 
//+------------------------------------------------------------------+
//| isTimeForUpdate                                                   |
//+------------------------------------------------------------------+ 
bool isTimeForUpdate()
{
   static datetime lasttime ;
   int diff = TimeLocal() - lasttime ;

   if (diff >= UpdateInterval )
   {
      lasttime = TimeLocal();
      return (true);
   }
   
   return (false);
   
} 

bool newBarDataTf()
{
   static datetime LastBar;
   datetime CurrBar = iTime(NULL, giDataTf, 0);

   if(LastBar != CurrBar)
   {
      LastBar = CurrBar;
      return (true);
   }
   return(false);  
}
//+------------------------------------------------------------------+
//| addStr                                                           |
//+------------------------------------------------------------------+ 
string addStr(string str, string char, int maxlength, bool atbeginning = true)
{
   int l = maxlength - StringLen(str);
   for (int i=0; i<l; i++)
   {
      if (atbeginning) str = char + str;
      else str = str + char;
   }
      
   return(str);
}
/**
 *
 */
bool isHistoryOK()
{    

   if (giProfileTf != PERIOD_Y1 && giProfileTf != PERIOD_Q1) 
   {
      if (  !checkHist(giProfileTf) 
         || !checkHist(giDataTf) 
         || !checkHist(Period())
      )  return(false); 
   }
   else
   {
      if (  !checkHist(giDataTf) 
         || !checkHist(Period())
      )  return(false);          
   }

   //Comment("");
   return(true);
}
/**
 *
 */
bool checkHist(int tf, int retries = 0/*second*/)
{
  
   int i, bars, err;
   double temp[][6];
   ArrayCopyRates(temp, NULL, tf);
   //bars = iBars(Symbol(), tf);      
   err  = GetLastError();   
      
   if (err==0) return(true);
   //Comment("Waiting for timeframe ", tf, " minutes to be ready");   
   
   return(false);

}
/**
 *getTfByName
 */
int getTfByName(string tfname)
{
   int p;
   
   if      (tfname == "Y1")  p = PERIOD_Y1;
   else if (tfname == "Q1")  p = PERIOD_Q1;       
   else if (tfname == "MN1") p = PERIOD_MN1;
   else if (tfname == "W1" ) p = PERIOD_W1;
   else if (tfname == "D1" ) p = PERIOD_D1;
   else if (tfname == "H4" ) p = PERIOD_H4;
   else if (tfname == "H1" ) p = PERIOD_H1;
   else if (tfname == "M30") p = PERIOD_M30;
   else if (tfname == "M15") p = PERIOD_M15;
   else if (tfname == "M5" ) p = PERIOD_M5;
   else if (tfname == "M1" ) p = PERIOD_M1;
   else p = Period();  
  
   return(p);  

} 
/**
 *getTfName
 */
string getTfName(int tf)
{
   string tfname;
   
   if      (tf == PERIOD_Y1)  tfname = "Y1";
   else if (tf == PERIOD_Q1)  tfname = "Q1";       
   else if (tf == PERIOD_MN1) tfname = "MN1";
   else if (tf == PERIOD_W1)  tfname = "W1";
   else if (tf == PERIOD_D1)  tfname = "D1";
   else if (tf == PERIOD_H4)  tfname = "H4";
   else if (tf == PERIOD_H1)  tfname = "H1";
   else if (tf == PERIOD_M30) tfname = "M30";
   else if (tf == PERIOD_M15) tfname = "M15";
   else if (tf == PERIOD_M5)  tfname = "M5";
   else if (tf == PERIOD_M1)  tfname = "M1";
   else tfname = "??";  
  
   return(tfname);  

}

/**
 *drawBar
 */
void drawBar( int barnum, int pos, double o, double h, double l, double c )
{
   color barclr;
   if (c>o)barclr=BarBullColor; else
   if (c<o)barclr=BarBearColor; else
           barclr=BarNeutralColor;   

   createTl("#" + barnum + ".bar.spread"
      , Time[pos], h
      , Time[pos], l
      , barclr, STYLE_SOLID, 2, false
      );            
   
   createTl("#" + barnum + ".bar.o"
      , Time[pos+1], o
      , Time[pos], o
      , barclr, STYLE_SOLID, 2, false
      ); 
      
   createTl("#" + barnum + ".bar.c"
      , Time[pos-1], c
      , Time[pos], c
      , barclr, STYLE_SOLID, 2, false
      );       
}

void getSesStartTime
( 
     datetime  dtDayStartHour
   , int&      sesorder
   , datetime& dtAsO
   , datetime& dtEuO
   , datetime& dtUsO
)
{
   if (giDayStartHour == AsiaOpen)
   {
      sesorder = SESORDTLN;   
           
      dtAsO = dtDayStartHour;                                 
      dtEuO = StrToTime(TimeToStr(dtDayStartHour, TIME_DATE)) + (EuropeOpen*PERIOD_H1*60);     
      dtUsO = StrToTime(TimeToStr(dtDayStartHour, TIME_DATE)) + (USOpen*PERIOD_H1*60);   
              
      if (AsiaOpen>EuropeOpen) { 
         dtEuO += PERIOD_D1*60;
         dtUsO += PERIOD_D1*60;
      }
              
   }
   else
   if (giDayStartHour == EuropeOpen)
   {
      sesorder = SESORDLNT; 
      
      dtAsO = StrToTime(TimeToStr(dtDayStartHour, TIME_DATE)) + ((24+AsiaOpen)*PERIOD_H1*60);
      dtEuO = dtDayStartHour;         
      dtUsO = StrToTime(TimeToStr(dtDayStartHour, TIME_DATE )) + (USOpen*PERIOD_H1*60);   
      
      
      if (AsiaOpen>EuropeOpen)  dtAsO -= (PERIOD_D1*60);                               
   }
   else
   if (giDayStartHour == USOpen)
   {
      sesorder = SESORDNTL; 
      
      dtAsO = StrToTime(TimeToStr( dtDayStartHour, TIME_DATE)) + ((24+AsiaOpen)*PERIOD_H1*60);        
      dtEuO = StrToTime(TimeToStr( dtDayStartHour, TIME_DATE)) + ((24+EuropeOpen)*PERIOD_H1*60);                   
      dtUsO = dtDayStartHour;
      
      
      if (AsiaOpen>USOpen)  dtAsO -= (PERIOD_D1*60); 
   }        
}

void getSbSessAndColor(
     int      sesorder
   , datetime bartime
   , datetime dtAsO
   , datetime dtEuO
   , datetime dtUsO
   , color&   clr
   , int&     sbsess
)
{
   switch (sesorder)
   {
      case SESORDLNT:   //london->newyork->tokyo  
         if (bartime >= dtAsO)
         { 
            clr = AsColor; sbsess = iBarShift(NULL, giDataTf, dtAsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtAsO) sbsess--;                       
         }
         else                       
         if (bartime >= dtUsO)
         { 
            clr = UsColor; sbsess = iBarShift(NULL, giDataTf, dtUsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtUsO) sbsess--;  
         }
         else
         //if (bartime >= dtEuO) 
         { 
            clr = EuColor; sbsess = iBarShift(NULL, giDataTf, dtEuO); 
            if (iTime(NULL, giDataTf, sbsess) < dtEuO) sbsess--;  
         }           
                  
         break;
         
      case SESORDNTL:   //newyork->london->tokyo
         if (bartime >= dtEuO) 
         { 
            clr = EuColor; sbsess = iBarShift(NULL, giDataTf, dtEuO); 
            if (iTime(NULL, giDataTf, sbsess) < dtEuO) sbsess--;  
         }  
         else
         if (bartime >= dtAsO) 
         { 
            clr = AsColor; sbsess = iBarShift(NULL, giDataTf, dtAsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtAsO) sbsess--;  
         }
         else
         //if (bartime >= dtUsO)
         { 
            clr = UsColor; sbsess = iBarShift(NULL, giDataTf, dtUsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtUsO) sbsess--;  
         }
                              
         break;
         
      default:    //tokyo london newyork
         if (bartime >= dtUsO)
         { 
            clr = UsColor; sbsess = iBarShift(NULL, giDataTf, dtUsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtUsO) sbsess--;  
         }
         else
         if (bartime >= dtEuO) 
         { 
            clr = EuColor; sbsess = iBarShift(NULL, giDataTf, dtEuO); 
            if (iTime(NULL, giDataTf, sbsess) < dtEuO) sbsess--;  
         }
         else
         //if (bartime >= dtAsO) 
         { 
            clr = AsColor; sbsess = iBarShift(NULL, giDataTf, dtAsO); 
            if (iTime(NULL, giDataTf, sbsess) < dtAsO) sbsess--;  
         }               
                                    
         break;                           
   }
}