/**
 *
 */
string getGVFullName(string name)
{
   return(INDNAME + "." + INDVER + "." + Symbol() + "." + IndicatorId + "." + ProfileTimeframe + "." + name);
}

/**
 * setConfig
 */
void setConfig()
{

   giProfileTf = getTfByName(ProfileTimeframe);
   
   if      (DayStartSession == "A") giDayStartHour = AsiaOpen;
   else if (DayStartSession == "B") giDayStartHour = EuropeOpen;
   else                             giDayStartHour = USOpen;
   
   if (ShowDIB && !ShowIB) ShowIB = true;
   
   switch (giProfileTf)
   {
      case PERIOD_Y1:
         giDataTf    = getTfByName(YearlyProfileDataTf);
         giIBTf      = getTfByName(YearlyIBTf); 
         giIBNumBars = YearlyIBNumBars;    
         giRowHeight = YearlyRowHeight;             
         break;
      case PERIOD_Q1:
         giDataTf    = getTfByName(QuarterlyProfileDataTf);
         giIBTf      = getTfByName(QuarterlyIBTf); 
         giIBNumBars = QuarterlyIBNumBars;        
         giRowHeight = QuarterlyRowHeight;             
         break;
      case PERIOD_MN1:
         giDataTf    = getTfByName(MonthlyProfileDataTf);
         giIBTf      = getTfByName(MonthlyIBTf); 
         giIBNumBars = MonthlyIBNumBars;
         giRowHeight = MonthlyRowHeight;                     
         break;
      case PERIOD_W1:
         giDataTf    = getTfByName(WeeklyProfileDataTf);
         giIBTf      = getTfByName(WeeklyIBTf); 
         giIBNumBars = WeeklyIBNumBars; 
         giRowHeight = WeeklyRowHeight;                    
         break;
      default:
         giDataTf    = getTfByName(DailyProfileDataTf);
         giIBTf      = getTfByName(DailyIBTf); 
         giIBNumBars = DailyIBNumBars; 
         giRowHeight = DailyRowHeight;                                      
         break;
                           
   }
              
   
   giStep = MathMax(giRowHeight, 1);

   ArrayCopyRates(gdaRates, NULL, giDataTf);
      
   //--> day/week/month letter color
   gcLtColor[0]  = LtColor1;
   gcLtColor[1]  = LtColor2;
   gcLtColor[2]  = LtColor3;
   gcLtColor[3]  = LtColor4;
   gcLtColor[4]  = LtColor5;
   gcLtColor[5]  = LtColor6;
   gcLtColor[6]  = LtColor7;
   gcLtColor[7]  = LtColor8;
   gcLtColor[8]  = LtColor9;
   gcLtColor[9]  = LtColor10;
   gcLtColor[10] = LtColor11;
   gcLtColor[11] = LtColor12;
   //<-- day/week/month letter color
      
   //-->On/Off Control
   storeCtrlSetting();
   
   giControlPosX[CTRLMODELETTER ] = XPOSCTRLMODELETTER;
   giControlPosX[CTRLPROFILEINFO] = XPOSCTRLPROFILEINFO;
   giControlPosX[CTRLOHLCBAR    ] = XPOSCTRLOHLCBAR;
   giControlPosX[CTRLIB         ] = XPOSCTRLIB;
   giControlPosX[CTRLDIB        ] = XPOSCTRLDIB;
   giControlPosX[CTRLTVPOINFO   ] = XPOSCTRLMONOCLR;   
   //<--On/Off Control
   
   //--> create gvar if not exist
   storeGVar(true);
   //<--
   
   //-->get gvar
   getGVar();
   //<--
}
/**
 * storeGVar
 */
void storeGVar(bool initval = false)
{
   int i, total = ArraySize(gsaGVName);
   string gvname;
   double val;
   bool exist; 
   for (i=0; i<total; i++)
   {
      gvname = getGVFullName(gsaGVName[i]);
      exist  = GlobalVariableCheck(gvname);
      
      if (initval && exist) continue;
            
      switch (i)
      {
         case GVMODELETTER:       val = ModeLetter;        break;
         case GVSHOWPROFILEINFO:  val = ShowProfileInfo;   break;
         case GVMONOCLRLETTERS:   val = MonoColorLetters;  break;
         case GVSHOWOHLCBAR:      val = ShowOHLCBar;       break;
         case GVSHOWIB:           val = ShowIB;            break;
         case GVSHOWDIB:          val = ShowDIB;           break;
      }
      
      GlobalVariableSet(gvname, val);
   }

}
/**
 * getGVar
 */
void getGVar()
{
   int i, total = ArraySize(gsaGVName);
   string gvname;
   
   for (i=0; i<total; i++)
   {
      gvname = getGVFullName(gsaGVName[i]);
                  
      switch (i)
      {
         case GVMODELETTER:      ModeLetter       = GlobalVariableGet(gvname); break;
         case GVSHOWPROFILEINFO: ShowProfileInfo  = GlobalVariableGet(gvname); break;
         case GVMONOCLRLETTERS:  MonoColorLetters = GlobalVariableGet(gvname); break;
         case GVSHOWOHLCBAR:     ShowOHLCBar      = GlobalVariableGet(gvname); break;
         case GVSHOWIB:          ShowIB           = GlobalVariableGet(gvname); break;
         case GVSHOWDIB:         ShowDIB          = GlobalVariableGet(gvname); break;
      }      
   }   
} 
/**
 *updateOnOffSetting
 */
bool updateOnOffSetting()
{
   
   int     i;
   string  objname;
   color   clr;   
   bool    changed = false;
   
   for (i=0; i<ArraySize(gbOnOffControl); i++)
   {
      objname = gsPref + "ctrl" + i;      
      if (ObjectFind(objname) != giWinId)
      {
         switch (i)
         {
            case CTRLMODELETTER:  ModeLetter       = !ModeLetter;         changed = true; break;
            case CTRLPROFILEINFO: ShowProfileInfo  = !ShowProfileInfo;    changed = true; break;
            case CTRLOHLCBAR:     ShowOHLCBar      = !ShowOHLCBar;        changed = true; break;
            case CTRLIB:          ShowIB           = !ShowIB;             changed = true; break;
            case CTRLDIB:         ShowDIB          = !ShowDIB;            changed = true; break;
            case CTRLTVPOINFO:    MonoColorLetters = !MonoColorLetters;   changed = true; break; 
         }    
      }      
   }      
   
   if (ShowDIB && !ShowIB) ShowIB = true;
   
   storeCtrlSetting();   
   drawOnOffControl();
   
   if (changed) storeGVar();
   
   return(changed);
} 

/**
 *
 */
void storeCtrlSetting()
{
   gbOnOffControl[CTRLMODELETTER ] = ModeLetter;
   gbOnOffControl[CTRLPROFILEINFO] = ShowProfileInfo;
   gbOnOffControl[CTRLOHLCBAR    ] = ShowOHLCBar;
   gbOnOffControl[CTRLIB         ] = ShowIB;   
   gbOnOffControl[CTRLDIB        ] = ShowDIB;
   gbOnOffControl[CTRLTVPOINFO   ] = MonoColorLetters;
}
/**
 *
 */
void displaySettingInfo()
{
   
   string ainfo[7];
   int    i, cnt, x=STARTX, y=STARTY;  
   color  clr;
   
   ainfo[0] = addStr("ProfileTF     : " + ProfileTimeframe        , " ", 25, false);
   ainfo[1] = addStr("ProfileDataTf : " + getTfName(giDataTf)     , " ", 25, false);
   ainfo[2] = addStr("IBTf          : " + getTfName(giIBTf)       , " ", 25, false);
   ainfo[3] = addStr("IBNumbars     : " + giIBNumBars + " Bar(s)" , " ", 25, false);
   ainfo[4] = addStr("RowHeight     : " + giRowHeight + " Pip(s)" , " ", 25, false);
   ainfo[5] = addStr("DayStartHour  : " + giDayStartHour          , " ", 25, false);
   ainfo[6] = "On/Off Setting: Del NUM ";
   
   if (giProfileTf == PERIOD_D1) cnt=6;
   else cnt=5;
    
   for (i = 0; i<cnt; i++)
   {
      lblCreate("info"+i, x, y, ainfo[i], INFOCORNER, InfoColor, FONTSIZE, FONTNAME, giWinId);  
      y+=12;
   }
           
   lblCreate("info"+i, STARTX+95, CTRLSTARTY+2, ainfo[6], INFOCORNER, InfoColor, FONTSIZE, FONTNAME, giWinId); 
   
   drawOnOffControl();
}

/**
 *drawOnOffControl
 */
void drawOnOffControl()
{
   int i;
   color clr;
   
   for (i=0; i<ArraySize(gbOnOffControl); i++)
   {
      if (gbOnOffControl[i]) clr = CTRLONCOLOR;
      else clr = CTRLOFFCOLOR;
      
      lblCreate("ctrl"+i, giControlPosX[i], CTRLSTARTY, CharToStr(140+i), INFOCORNER, clr, 11, "Wingdings", giWinId);

   }   
   
}  